searchData={"items":[{"type":"module","title":"XFsm","doc":"Documentation for `XFsm`.","ref":"XFsm.html"},{"type":"type","title":"XFsm.action_arg/0","doc":"","ref":"XFsm.html#t:action_arg/0"},{"type":"type","title":"XFsm.callback/0","doc":"","ref":"XFsm.html#t:callback/0"},{"type":"type","title":"XFsm.context/0","doc":"","ref":"XFsm.html#t:context/0"},{"type":"type","title":"XFsm.event/0","doc":"","ref":"XFsm.html#t:event/0"},{"type":"type","title":"XFsm.self/0","doc":"","ref":"XFsm.html#t:self/0"},{"type":"module","title":"XFsm.Actions","doc":"Documentation for `XFsm.Actions`.","ref":"XFsm.Actions.html"},{"type":"function","title":"XFsm.Actions.assigns/2","doc":"","ref":"XFsm.Actions.html#assigns/2"},{"type":"function","title":"XFsm.Actions.cancel/2","doc":"","ref":"XFsm.Actions.html#cancel/2"},{"type":"function","title":"XFsm.Actions.send_event/3","doc":"","ref":"XFsm.Actions.html#send_event/3"},{"type":"module","title":"XFsm.Actor","doc":"Documentation for `XFsm.Actor`.","ref":"XFsm.Actor.html"},{"type":"function","title":"XFsm.Actor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"XFsm.Actor.html#child_spec/1"},{"type":"function","title":"XFsm.Actor.send/2","doc":"","ref":"XFsm.Actor.html#send/2"},{"type":"function","title":"XFsm.Actor.snapshot/1","doc":"","ref":"XFsm.Actor.html#snapshot/1"},{"type":"function","title":"XFsm.Actor.start_link/1","doc":"","ref":"XFsm.Actor.html#start_link/1"},{"type":"function","title":"XFsm.Actor.subscribe/2","doc":"","ref":"XFsm.Actor.html#subscribe/2"},{"type":"function","title":"XFsm.Actor.unsubscribe/2","doc":"","ref":"XFsm.Actor.html#unsubscribe/2"},{"type":"module","title":"XFsm.Always","doc":"Documentation for `XFsm.Always`.","ref":"XFsm.Always.html"},{"type":"type","title":"XFsm.Always.t/0","doc":"","ref":"XFsm.Always.html#t:t/0"},{"type":"module","title":"XFsm.Builder","doc":"Documentation for `XFsm.Builder`.","ref":"XFsm.Builder.html"},{"type":"macro","title":"XFsm.Builder.context/1","doc":"","ref":"XFsm.Builder.html#context/1"},{"type":"macro","title":"XFsm.Builder.context/2","doc":"","ref":"XFsm.Builder.html#context/2"},{"type":"macro","title":"XFsm.Builder.defa/2","doc":"","ref":"XFsm.Builder.html#defa/2"},{"type":"macro","title":"XFsm.Builder.defg/2","doc":"","ref":"XFsm.Builder.html#defg/2"},{"type":"macro","title":"XFsm.Builder.initial/1","doc":"","ref":"XFsm.Builder.html#initial/1"},{"type":"macro","title":"XFsm.Builder.root/1","doc":"","ref":"XFsm.Builder.html#root/1"},{"type":"macro","title":"XFsm.Builder.state/2","doc":"","ref":"XFsm.Builder.html#state/2"},{"type":"module","title":"XFsm.Event","doc":"Documentation for `XFsm.Event`.","ref":"XFsm.Event.html"},{"type":"type","title":"XFsm.Event.t/0","doc":"","ref":"XFsm.Event.html#t:t/0"},{"type":"module","title":"XFsm.Machine","doc":"Documentation for `XFsm.Machine`.","ref":"XFsm.Machine.html"},{"type":"function","title":"XFsm.Machine.init/2","doc":"","ref":"XFsm.Machine.html#init/2"},{"type":"type","title":"XFsm.Machine.t/0","doc":"","ref":"XFsm.Machine.html#t:t/0"},{"type":"function","title":"XFsm.Machine.transition/2","doc":"","ref":"XFsm.Machine.html#transition/2"},{"type":"module","title":"XFsm.Snapshot","doc":"Documentation for `XFsm.Snapshot`.","ref":"XFsm.Snapshot.html"},{"type":"type","title":"XFsm.Snapshot.t/0","doc":"","ref":"XFsm.Snapshot.html#t:t/0"},{"type":"module","title":"XFsm.State","doc":"Documentation for `XFsm.State`.","ref":"XFsm.State.html"},{"type":"function","title":"XFsm.State.add_always/2","doc":"","ref":"XFsm.State.html#add_always/2"},{"type":"function","title":"XFsm.State.add_event/2","doc":"","ref":"XFsm.State.html#add_event/2"},{"type":"type","title":"XFsm.State.t/0","doc":"","ref":"XFsm.State.html#t:t/0"},{"type":"module","title":"XFsm.Timers","doc":"Documentation for `XFsm.Timers`.","ref":"XFsm.Timers.html"},{"type":"function","title":"XFsm.Timers.add/2","doc":"","ref":"XFsm.Timers.html#add/2"},{"type":"function","title":"XFsm.Timers.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"XFsm.Timers.html#child_spec/1"},{"type":"function","title":"XFsm.Timers.remove/1","doc":"","ref":"XFsm.Timers.html#remove/1"},{"type":"function","title":"XFsm.Timers.start_link/1","doc":"","ref":"XFsm.Timers.html#start_link/1"},{"type":"extras","title":"Quickstart","doc":"# Quickstart\n\nThis guide will help you get started with XFsm. You will learn how to create a state machine, create an actor from the state machine, send events to the actor, and use it outside of an actor.\n\n> #### Info {: .info}\n>\n> The quickest way to start with XFsm is to check out the [Basic Payment Machine](https://github.com/heywhy/xfsm/blob/main/test/payment_actor_test.exs). There you will find an example of a machine that covers the basics of XFsm.","ref":"quickstart.html"},{"type":"extras","title":"Installing XFsm - Quickstart","doc":"[XFsm](../README.md) is a declarative state management and orchestration library for Elixir.\n\n```elixir\ndef deps do\n  [\n    {:xfsm, \"~> 0.3\"}\n  ]\nend\n```","ref":"quickstart.html#installing-xfsm"},{"type":"extras","title":"Create a Machine - Quickstart","doc":"In XFsm, a [machine](../lib/xfsm/machine.ex) is a module that contains all the logic for the actor. In this example, we will create a simple toggle machine that can be in one of two states: `on` or `off`. The `press` event will toggle the state between `on` and `off`.\n\n```elixir\ndefmodule LightbulbSwitch do\n  use XFsm.Actor\n  use XFsm.Machine\n\n  initial(:off)\n\n  state :off do\n    on :press do\n      target(:on)\n    end\n  end\n\n  state :on do\n    on :press do\n      target(:off)\n    end\n  end\nend\n```\n\nJust by looking at the declaration, you can get a sense of how it works. To familiarize yourself with the foundational concepts, read our [introduction to state machines guide](./machines.md).","ref":"quickstart.html#create-a-machine"},{"type":"extras","title":"Start an Actor and Send Events - Quickstart","doc":"An actor is a running process that can receive events, send events to other actors, and change its behavior based on the events it receives.\n\n```elixir\nalias XFsm.{Actor, Snapshot}\n\n# Here, we start the actor.\n{:ok, pid} = LightbulbSwitch.start_link()\n\n# Grab a snapshot of the actor's state.\n%Snapshot{state: :off} = Actor.snapshot(pid)\n\n# Send the `press` event to the actor.\n:ok = Actor.send(pid, %{type: :press})\n\n# Notice that the state of the actor has now changed?!\n%Snapshot{state: :on} = Actor.snapshot(pid)\n\n# Send another `press` event to the actor.\n:ok = Actor.send(pid, %{type: :press})\n\n# Now we're back to the initial state.\n%Snapshot{state: :off} = Actor.snapshot(pid)\n```\n\n> #### Info {: .info}\n>\n> Ensure your machine utilizes the `use XFsm.Actor` behavior. Additionally, XFsm actors are GenServers under the hood but have a more restricted scope of behavior.","ref":"quickstart.html#start-an-actor-and-send-events"},{"type":"extras","title":"Context Data - Quickstart","doc":"Context is how you store data within a state machine actor.\n\n```elixir\ndefmodule ToggleMachine do\n  use XFsm.Actor\n  use XFsm.Machine\n\n  import XFsm.Actions\n\n  initial(:inactive)\n  context(%{count: 0})\n\n  state :inactive do\n    on :toggle do\n      target(:active)\n    end\n  end\n\n  state :active do\n    # Increment `count` every time we transition into this state.\n    entry(assigns(%{count: &(&1.context.count + 1)}))\n\n    on :toggle do\n      target(:inactive)\n    end\n  end\nend\n```","ref":"quickstart.html#context-data"},{"type":"extras","title":"Machine Input - Quickstart","doc":"[Machine Input](./input.md) is how initial data can be passed to a machine actor. Meanwhile, [Guards](./guards.md) are used to conditionally allow or disallow transitions.\n\n```elixir\ndefmodule ToggleMachine do\n  use XFsm.Actor\n  use XFsm.Machine\n\n  import XFsm.Actions\n\n  initial(:inactive)\n  context(%{input: input}, do: %{count: 0, max_count: input.max_count})\n\n  state :inactive do\n    on :toggle do\n      target(:active)\n      guard(%{context: context}, do: context.count < context.max_count)\n    end\n  end\n\n  state :active do\n    entry(assigns(%{count: &(&1.context.count + 1)}))\n\n    on :toggle do\n      target(:inactive)\n    end\n  end\nend\n\nalias XFsm.Actor\n\n{:ok, pid} = ToggleMachine.start_link(input: %{max_count: 10})\n\nActor.subscribe(pid, &IO.inspect/1)\n\nActor.send(pid, %{type: :toggle})\n```","ref":"quickstart.html#machine-input"},{"type":"extras","title":"Install XFsm","doc":"# Install XFsm\n\nXFsm has **zero dependencies** and runs in any Beam environment. You can install XFsm by visiting the [Hex](https://hex.pm/packages/xfsm), you will find the latest version and how to install using supported package managers.","ref":"installation.html"},{"type":"extras","title":"Cheatsheet","doc":"# Cheatsheet\n\nUse this cheatsheet to quickly lookup the APIs for XFsm.","ref":"cheatsheet.html"},{"type":"extras","title":"Examples - Cheatsheet","doc":"{: .col-2}","ref":"cheatsheet.html#examples"},{"type":"extras","title":"Creating a state machine - Cheatsheet","doc":"```elixir\ndefmodule ToggleMachine do\n  use XFsm.Actor\n  use XFsm.Machine\n\n  initial(:active)\n  context(%{count: 0})\n\n  state :active do\n    entry(assigns(%{count: &(&1.context.count +1)}))\n\n    on :toggle, do: target(:inactive)\n  end\n\n  state :inactive do\n    on :toggle, do: target(:active)\n  end\nend\n\nalias XFsm.Actor\n\n{:ok, pid} = ToggleMachine.start_link()\n\nActor.subscribe(pid, &IO.puts/1)\n\nActor.send(pid, %{type: :toggle})\n# logs 'inactive' with context %{count: 1}\n\nActor.send(pid, %{type: :toggle})\n# logs 'active' with context %{count: 2}\n\nActor.send(pid, %{type: :toggle})\n# logs 'inactive' with context %{count: 2}\n```","ref":"cheatsheet.html#creating-a-state-machine"},{"type":"extras","title":"Guards - Cheatsheet","doc":"```elixir\ndefmodule ToggleMachine do\n  use XFsm.Actor\n  use XFsm.Machine\n\n  initial(:active)\n  context(%{activate?: false})\n\n  state :inactive do\n    on :toggle do\n      target(:active)\n      guard(:toggle?)\n    end\n\n    on :toggle do\n      action(:notify_not_allowed)\n    end\n  end\n\n  state :active do\n    on :toggle do\n      target(:inactive)\n      guard(%{\n        method: :after_time?,\n        params: %{time: \"00:00\"}\n      })\n    end\n  end\n\n  defg toggle?(%{context: context}), do: context.activate?\n\n  defg after_time?(_, %{time: time}) do\n    now = DateTime.utc_now()\n    [hour, minute] = String.split(time, \":\")\n    {hour, \"\"} = Integer.parse(hour)\n    {minute, \"\"} = Integer.parse(minute)\n\n    now.hour > hour and now.minute > minute\n  end\n\n  defa notify_not_allowed(%{context: context}) do\n    IO.puts(\"Cannot be toggled\")\n    context\n  end\nend\n```","ref":"cheatsheet.html#guards"},{"type":"extras","title":"Actions - Cheatsheet","doc":"```elixir\ndefmodule ToggleMachine do\n  use XFsm.Actor\n  use XFsm.Machine\n\n  initial(:active)\n\n  state :active do\n    entry(:activate)\n    exit(:deactivate)\n\n    on :toggle do\n      target(:inactive)\n      action(:notify)\n    end\n  end\n\n  state :inactive do\n    on :toggle do\n      target(:active)\n      action(%{\n        method: :notify,\n        params: %{message: \"Some notification\"}\n      })\n    end\n  end\n\n  defa activate(_) do\n    # ...\n  end\n\n  defa deactivate(_) do\n    # ...\n  end\n\n  defa notify(_,  %{message: _}) do\n    # ...\n  end\nend\n```","ref":"cheatsheet.html#actions"},{"type":"extras","title":"State machines","doc":"# What are State Machines?\n\nState machines are models used to visualize how an object changes its state based on external events.\n\nThis model is essential in software engineering because it helps capture the various states of an entity, the events that trigger changes, and the transitions between these states. Additionally, it assists in identifying impossible states and undesirable transitions.\n\nSome benefits of using a state machine include:\n\n- They are simple to understand and can be easily communicated across different levels of an organization.\n- They are easy to maintain and test because the states and transitions are deterministic.\n- They provide a concise way to model complex application workflows.","ref":"state-machines.html"},{"type":"extras","title":"States - State machines","doc":"A state describes the condition of a machine at any given time.\n\nFor example, a lightbulb is either **on** or **off**; it can never be both simultaneously. Furthermore, it is **impossible** for it to be neither **on** nor **off**.\n\n```mermaid\n---\ntitle: Lightbulb\n---\nflowchart LR\n\non ~~~~ off\n```\n\nIn the example above, there are only two states, which are *finite*.\n\nWhen a machine starts, it first enters the **initial state**. A machine cannot have multiple initial states because it wouldn't be able to determine which state to enter.\n\n> #### Info {: .info}\n>\n> A state machine can only be in one state at a time.\n\n[Read more about states](./state.md)","ref":"state-machines.html#states"},{"type":"extras","title":"States in XFsm - State machines","doc":"In XFsm, states are defined using the `state` attribute.\n\n```elixir\ndefmodule Lightbulb do\n  use XFsm.Machine\n\n  initial(:off)\n\n  state :off do\n  end\n\n  state :on do\n  end\nend\n```","ref":"state-machines.html#states-in-xfsm"},{"type":"extras","title":"Transitions - State machines","doc":"The process of how a lightbulb goes from **off** to **on** is referred to as **transitions**. **Events** trigger transitions; when a known event occurs, the machine transitions to the next state.\n\nThe lightbulb alternates between **on** and **off** through the **turn_on** and **turn_off** events.\n\nTransitions are deterministic; each combination of state and event always points to the same next state.\n\n```mermaid\n---\ntitle: Lightbulb\n---\nstateDiagram-v2\n\n[*] --> off\noff --> on: turn_on\non --> off: turn_off\n```\n\nWith its two finite states and transitions, this lightbulb process is a *Finite State Machine*. A state machine is used to describe the behavior of something. The machine outlines the thing’s states and the transitions between them. It’s considered a Finite State Machine because it has a finite number of states.\n\n[Read more about transitions and events](./transitions.md)","ref":"state-machines.html#transitions"},{"type":"extras","title":"Events and Transitions in XFsm - State machines","doc":"Events and transitions are defined in XFsm state machines inside the `on` property of a state.\n\n```elixir\ndefmodule Lightbulb do\n  use XFsm.Machine\n\n  initial(:off)\n\n  state :off do\n    on :turn_on, do: target(:on)\n  end\n\n  state :on do\n    off :turn_off, do: target(:off)\n  end\nend\n```","ref":"state-machines.html#events-and-transitions-in-xfsm"},{"type":"extras","title":"Final State - State machines","doc":"Most processes with states will have a final state, which is the last state when the process is completed.","ref":"state-machines.html#final-state"},{"type":"extras","title":"Self-transition - State machines","doc":"Self-transition happens when an event occurs, but the transition returns to the same state. The transition arrows exits and re-enter the same state.\n\nA helpful way to describe a self-transition is “doing something, not going somewhere” in the process.\n\n```mermaid\nstateDiagram-v2\n\nstate \"state\" as a\n\n[*] --> a\na --> a: transition\n```\n\n[Read more about self transitions](./eventless-transitions.md)","ref":"state-machines.html#self-transition"},{"type":"extras","title":"What is XFsm","doc":"# XFsm\n\n[![Dialyzer](https://github.com/heywhy/xfsm/actions/workflows/dialyzer.yml/badge.svg?branch=main)](https://github.com/heywhy/xfsm/actions) [![Test](https://github.com/heywhy/xfsm/actions/workflows/test.yml/badge.svg?branch=main)](https://github.com/heywhy/xfsm/actions) [![Codecov](https://codecov.io/gh/heywhy/xfsm/branch/main/graph/badge.svg?token=ZDA9GUTAFJ)](https://codecov.io/gh/heywhy/xfsm)\n\nXFsm is a declarative finite state machine library for [Elixir](https://elixir-lang.org/).\n\nIt uses [event-driven](./docs/transitions.md) programming, [state machines](./docs/state-machines.md) and actors to handle complex logic in predictable and robust ways.\n\nIt provides very easy to use APIs which makes looking at a declaration very easy to understand.","ref":"readme.html"},{"type":"extras","title":"Installation - What is XFsm","doc":"The package can be installed by adding `xfsm` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:xfsm, \"~> 0.5.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Documentation - What is XFsm","doc":"API documentation is available at","ref":"readme.html#documentation"},{"type":"extras","title":"Create a simple machine - What is XFsm","doc":"```elixir\ndefmodule Counter do\n  use XFsm.Actor\n  use XFsm.Machine\n\n  import XFsm.Actions\n\n  context(%{count: 0})\n\n  on :inc do\n    action(assigns(%{count: & &1.context.count + 1}))\n  end\n\n  on :dec do\n    action(assigns(%{count: & &1.context.count - 1}))\n  end\n\n  on :set do\n    action(assigns(%{count: & &1.event.value}))\n  end\nend\n\nalias XFsm.Actor\n\n{:ok, pid} = Counter.start_link()\n\nActor.subscribe(pid, fn %{context: %{count: count}} ->\n  IO.puts(count)\nend)\n\nActor.send(pid, %{type: :inc})\n# logs 1\n\nActor.send(pid, %{type: :dec})\n# logs 0\n\nActor.send(pid, %{type: :set, value: 10})\n# logs 10\n```\n\n```mermaid\n---\ntitle: Counter machine\n---\nflowchart LR\n\ninc --> machine\ndec --> machine\nset --> machine\nmachine --- inc\nmachine --- dec\nmachine --- set\n\nmachine@{shape: diam, label: \"Machine\"}\ndec@{shape: event, label: \"DEC\\nassigns(...)\"}\ninc@{shape: event, label: \"INC\\nassigns(...)\"}\nset@{shape: event, label: \"SET\\nassigns(...)\"}\n```","ref":"readme.html#create-a-simple-machine"},{"type":"extras","title":"Create a complex machine - What is XFsm","doc":"```elixir\ndefmodule TicTacToe do\n  use XFsm.Actor\n  use XFsm.Machine\n\n  import XFsm.Actions\n\n  defmodule Board do\n    defstruct squares: {nil, nil, nil, nil, nil, nil, nil, nil, nil}\n\n    @tags [:x, :o]\n\n    def square(%__MODULE__{} = board, index)\n        when is_integer(index) and index >= 1 and index <= 9 do\n      elem(board.squares, index - 1)\n    end\n\n    def empty?(%__MODULE__{} = board, index), do: square(board, index) == nil\n\n    def has_empty_square?(%__MODULE__{} = board) do\n      Enum.any?(0..8, &(elem(board.squares, &1) == nil))\n    end\n\n    def draw?(%__MODULE__{} = board) do\n      not has_empty_square?(board) and\n        not (won?(board, :x) or won?(board, :o))\n    end\n\n    def won?(%__MODULE__{} = board, tag) when tag in @tags do\n      %{squares: squares} = board\n\n      siblings?(:x, squares, tag) or\n        siblings?(:y, squares, tag) or\n        siblings?(:z, squares, tag)\n    end\n\n    def put(%__MODULE__{} = board, index, tag)\n        when is_integer(index) and index >= 1 and index <= 9 and tag in @tags do\n      case empty?(board, index) do\n        false ->\n          board\n\n        true ->\n          squares = put_elem(board.squares, index - 1, tag)\n\n          %__MODULE__{board | squares: squares}\n      end\n    end\n\n    def to_iodata(%__MODULE__{} = board) do\n      Enum.reduce(0..2, [], fn i, acc ->\n        row = Enum.map_join(0..2, \"|\", &(elem(board.squares, i * 3 + &1) || \"-\"))\n\n        Enum.concat(acc, [\"|\", row, \"|\\n\"])\n      end)\n    end\n\n    defp siblings?(:x, squares, tag) do\n      Enum.reduce_while(0..2, false, fn i, acc ->\n        fun? = &(elem(squares, i * 3 + &1) == tag)\n\n        case Enum.all?(0..2, fun?) do\n          true -> {:halt, true}\n          false -> {:cont, acc}\n        end\n      end)\n    end\n\n    defp siblings?(:y, squares, tag) do\n      Enum.reduce_while(0..2, false, fn i, acc ->\n        fun? = &(elem(squares, i + &1 * 3) == tag)\n\n        case Enum.all?(0..2, fun?) do\n          true -> {:halt, true}\n          false -> {:cont, acc}\n        end\n      end)\n    end\n\n    defp siblings?(:z, squares, tag) do\n      fun? = &(elem(squares, &1) == tag)\n\n      Enum.all?(0..8//4, fun?) or Enum.all?(2..6//2, fun?)\n    end\n  end\n\n  initial(:x)\n  context(%{input: i}, do: context_from_input(i))\n\n  state :x do\n    on :move do\n      target(:o)\n      guard(%{method: :can_move?, params: %{player: :x}})\n      action(:make_move)\n    end\n  end\n\n  state :o do\n    on :move do\n      target(:x)\n      guard(%{method: :can_move?, params: %{player: :o}})\n      action(:make_move)\n    end\n  end\n\n  state :end do\n    # You most likely want to persist the game state and terminate the\n    # process, assuming you're building an online multiplayer game.\n  end\n\n  root do\n    always do\n      target(:end)\n      guard(%{method: :won?, params: %{player: :o}})\n      action(assigns(%{winner: :o}))\n    end\n\n    always do\n      target(:end)\n      guard(%{method: :won?, params: %{player: :x}})\n      action(assigns(%{winner: :x}))\n    end\n\n    always do\n      target(:end)\n      guard(%{method: :drawn?, params: %{player: :x}})\n    end\n  end\n\n  defg can_move?(\n         %{context: %{x: x}, event: %{ref: x, square: s}} = arg,\n         %{player: :x}\n       )\n       when is_integer(s) and s >= 1 and s <= 9 do\n    %{context: %{board: board}, event: %{square: square}} = arg\n\n    Board.empty?(board, square)\n  end\n\n  defg can_move?(\n         %{context: %{o: o}, event: %{ref: o, square: s}} = arg,\n         %{player: :o}\n       )\n       when is_integer(s) and s >= 1 and s <= 9 do\n    %{context: %{board: board}, event: %{square: square}} = arg\n\n    Board.empty?(board, square)\n  end\n\n  defg won?(\n         %{self: %{state: _}, context: %{board: _}} = arg,\n         %{player: player} = params\n       )\n       when player in [:x, :o] do\n    %{self: %{state: state}, context: %{board: board}} = arg\n    %{player: player} = params\n\n    state != :end and Board.won?(board, player)\n  end\n\n  defg drawn?(%{self: %{state: _}, context: %{board: _}} = arg) do\n    %{self: %{state: state}, context: %{board: board}} = arg\n\n    state != :end and Board.draw?(board)\n  end\n\n  defa make_move(%{context: %{x: x} = c, event: %{ref: x, square: s}})\n       when is_integer(s) and s >= 1 and s <= 9 do\n    %{board: board} = c\n    board = Board.put(board, s, :x)\n\n    %{c | board: board}\n  end\n\n  defa make_move(%{context: %{o: o} = c, event: %{ref: o, square: s}})\n       when is_integer(s) and s >= 1 and s <= 9 do\n    %{board: board} = c\n    board = Board.put(board, s, :o)\n\n    %{c | board: board}\n  end\n\n  defp context_from_input(%{x: x, o: o})\n       when is_reference(x) and is_reference(o) do\n    %{x: x, o: o, winner: :none, board: %Board{}}\n  end\nend\n\nalias XFsm.Actor\n\n# We're using references so that a player does not make a move for the other.\n# These can be user id assuming you're building an online multiplayer game.\nx = make_ref()\no = make_ref()\n\n{:ok, pid} = TicTacToe.start_link(input: %{x: x, o: o})\n\nActor.subscribe(pid, fn %{context: %{board: b, winner: w}} ->\n  iodata = TicTacToe.Board.to_iodata(b)\n\n  IO.puts([iodata | [\"\\n\", \"winner: \", Atom.to_string(w)]])\nend)\n\n:ok = Actor.send(pid, %{type: :move, ref: x, square: 5})\n:ok = Actor.send(pid, %{type: :move, ref: o, square: 3})\n:ok = Actor.send(pid, %{type: :move, ref: x, square: 6})\n:ok = Actor.send(pid, %{type: :move, ref: o, square: 1})\n:ok = Actor.send(pid, %{type: :move, ref: x, square: 4})\n\nXFsm.Actor.snapshot(pid)\n```\n\n```mermaid\nstateDiagram-v2\n\nstate x_if_end < >\nstate o_if_end < >\n\nstate \"player x\" as x\nstate \"player o\" as o\n\n[*] --> x\nx --> x_if_end\nx_if_end --> end: if pos = draw or win\nx --> o: move\n\no --> o_if_end\no_if_end --> end: if pos = draw or win\no --> x: move\n```","ref":"readme.html#create-a-complex-machine"},{"type":"extras","title":"License - What is XFsm","doc":"MIT","ref":"readme.html#license"},{"type":"extras","title":"Machines","doc":"# Machines","ref":"machines.html"},{"type":"extras","title":"State","doc":"# State","ref":"state.html"},{"type":"extras","title":"Input","doc":"# Input","ref":"input.html"},{"type":"extras","title":"Transitions","doc":"# Transitions","ref":"transitions.html"},{"type":"extras","title":"Eventless Transitions","doc":"# Eventless Transitions","ref":"eventless-transitions.html"},{"type":"extras","title":"Actions","doc":"# Actions","ref":"actions.html"},{"type":"extras","title":"Guards","doc":"# Guards","ref":"guards.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}